routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

//Route::get('/', function () {
//    return view('welcome');
//});

Route::middleware('guest')->group(function () {
    Route::get('/', 'AuthController@index')->name('login');
    Route::post('/login', 'AuthController@login')->name('auth.login');
});

Route::middleware('auth')->group(function () {
    Route::post('/logout', 'AuthController@logout')->name('auth.logout');

    Route::resource('events', 'EventController')->only(['index', 'store', 'create']);

    Route::middleware('check.event')->group(function () {
        Route::resource('events', 'EventController')->except(['index', 'store', 'create']);
        Route::resource('events/{event}/tickets', 'TicketController');
        Route::resource('events/{event}/channels', 'ChannelController');
        Route::resource('events/{event}/rooms', 'RoomController');
        Route::resource('events/{event}/sessions', 'SessionController');
        Route::get('events/{event}/reports', 'ReportController@index')->name('reports.index');
    });
});

app/Event.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Event extends Model
{
    public $timestamps = false;
    protected $guarded = [];

    public function registrations()
    {
        return $this->hasManyThrough('App\Registration', 'App\Ticket');
    }

    public function tickets()
    {
        return $this->hasMany('App\Ticket');
    }

    public function channels()
    {
        return $this->hasMany('App\Channel');
    }

    public function organizer()
    {
        return $this->belongsTo('App\Organizer');
    }
}

app/Http/Controllers/Api/EventController.php
<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\Event;
use App\Http\Resources\EventResource;
use App\Organizer;
use App\Http\Resources\EventDetailResource;

class EventController extends Controller
{
    public function index()
    {
        $events = Event::where('date', '>', date('Y-m-d'))->orderBy('date', 'ASC')->get();
        return response()->json(['events' => EventResource::collection($events)]);
    }

    public function detail($organizer_slug, $event_slug)
    {
        $organizer = Organizer::where('slug', $organizer_slug)->first();
        if (!$organizer) {
            return response()->json(['message' => 'Organizer not found'], 404);
        }

        $event = $organizer->events()->where('slug', $event_slug)->first();
        if (!$event) {
            return response()->json(['message' => 'Event not found'], 404);
        }

        return response()->json(new EventDetailResource($event));
    }
}

app/Http/Controllers/EventController.php
<?php

namespace App\Http\Controllers;

use App\Event;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

class EventController extends Controller
{
    public function index()
    {
        $events = Auth::user()->events()->orderBy('date', 'ASC')->get();
        return view('events.index', compact('events'));
    }

    public function create()
    {
        return view('events.create');
    }

    public function store(Request $request)
    {
        $request->validate([
            'name' => 'required',
            'slug' => 'required|unique:events,slug,null,null,organizer_id,' . Auth::user()->id . '|regex:/^[0-9a-z-]+$/',
            'date' => 'required|date_format:Y-m-d'
        ], [
            'slug.unique' => 'Slug is already used',
            'slug.regex' => 'Slug must not be empty and only contain a-z, 0-9 and \'-\''
        ]);

        $input = $request->only(['name', 'slug', 'date']);

        $event = Auth::user()->events()->save(new Event($input));
        return redirect()->route('events.show', $event->id)->with('success', 'Event successfully created');
    }

    public function show(Event $event)
    {
        return view('events.detail', compact('event'));
    }

    public function edit(Event $event)
    {
        return view('events.edit', compact('event'));
    }

    public function update(Request $request, Event $event)
    {
        $request->validate([
            'name' => 'required',
            'slug' => 'required|unique:events,slug,' . $event->id . ',id,organizer_id,' . Auth::user()->id . '|regex:/^[0-9a-z-]+$/',
            'date' => 'required|date_format:Y-m-d'
        ], [
            'slug.unique' => 'Slug is already used',
            'slug.regex' => 'Slug must not be empty and only contain a-z, 0-9 and \'-\''
        ]);

        $input = $request->only(['name', 'slug', 'date']);

        $event->update($input);
        return redirect()->route('events.show', $event->id)->with('success', 'Event successfully updated');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}

resources/views/events/create.blade.php
@extends('layouts.app')

@section('main')
    <div
        class="d-flex justify-content-between flex-wrap flex-md-nowrap align-items-center pt-3 pb-2 mb-3 border-bottom">
        <h1 class="h2">Manage Events</h1>
    </div>

    <div class="mb-3 pt-3 pb-2">
        <div class="d-flex justify-content-between flex-wrap flex-md-nowrap align-items-center">
            <h2 class="h4">Create new event</h2>
        </div>
    </div>

    <form class="needs-validation" novalidate action="{{route('events.store')}}" method="POST">
        @csrf

        <div class="row">
            <div class="col-12 col-lg-4 mb-3">
                <label for="inputName">Name</label>
                <input type="text" class="form-control @if($errors->has('name')) is-invalid @endif" id="inputName"
                       name="name" placeholder="" value="{{old('name', '')}}">
                @if($errors->has('name'))
                    <div class="invalid-feedback">
                        {{$errors->first('name')}}
                    </div>
                @endif
            </div>
        </div>

        <div class="row">
            <div class="col-12 col-lg-4 mb-3">
                <label for="inputSlug">Slug</label>
                <input type="text" class="form-control @if($errors->has('slug')) is-invalid @endif" id="inputSlug"
                       name="slug" placeholder="" value="{{old('slug', '')}}">
                @if($errors->has('slug'))
                    <div class="invalid-feedback">
                        {{$errors->first('slug')}}
                    </div>
                @endif
            </div>
        </div>

        <div class="row">
            <div class="col-12 col-lg-4 mb-3">
                <label for="inputDate">Date</label>
                <input type="text"
                       class="form-control @if($errors->has('date')) is-invalid @endif"
                       id="inputDate"
                       name="date"
                       placeholder="yyyy-mm-dd"
                       value="{{old('date', '')}}">
                @if($errors->has('date'))
                    <div class="invalid-feedback">
                        {{$errors->first('date')}}
                    </div>
                @endif
            </div>
        </div>

        <hr class="mb-4">
        <button class="btn btn-primary" type="submit">Save event</button>
        <a href="{{route('events.index')}}" class="btn btn-link">Cancel</a>
    </form>
@endsection

resources/views/events/detail.blade.php
@extends('layouts.app')

@section('main')
    <div class="border-bottom mb-3 pt-3 pb-2 event-title">
        <div class="d-flex justify-content-between flex-wrap flex-md-nowrap align-items-center">
            <h1 class="h2">{{$event->name}}</h1>
            <div class="btn-toolbar mb-2 mb-md-0">
                <div class="btn-group mr-2">
                    <a href="{{route('events.edit', $event->id)}}" class="btn btn-sm btn-outline-secondary">Edit
                        event</a>
                </div>
            </div>
        </div>
        <span class="h6">{{$event->date}}</span>
    </div>

    <!-- Tickets -->
    <div id="tickets" class="mb-3 pt-3 pb-2">
        <div class="d-flex justify-content-between flex-wrap flex-md-nowrap align-items-center">
            <h2 class="h4">Tickets</h2>
            <div class="btn-toolbar mb-2 mb-md-0">
                <div class="btn-group mr-2">
                    <a href="{{route('tickets.create', $event->id)}}" class="btn btn-sm btn-outline-secondary">
                        Create new ticket
                    </a>
                </div>
            </div>
        </div>
    </div>

    <div class="row tickets">
        @foreach ($event->tickets as $ticket)
            <div class="col-md-4">
                <div class="card mb-4 shadow-sm">
                    <div class="card-body">
                        <h5 class="card-title">{{$ticket->name}}</h5>
                        <p class="card-text">{{$ticket->cost}}</p>
                        <p class="card-text">
                            @if ($ticket->description)
                                {{$ticket->description}}
                            @else
                                &nbsp;
                            @endif
                        </p>
                    </div>
                </div>
            </div>
        @endforeach
    </div>

    <!-- Sessions -->
    <div id="sessions" class="mb-3 pt-3 pb-2">
        <div class="d-flex justify-content-between flex-wrap flex-md-nowrap align-items-center">
            <h2 class="h4">Sessions</h2>
            <div class="btn-toolbar mb-2 mb-md-0">
                <div class="btn-group mr-2">
                    <a href="{{route('sessions.create', $event->id)}}" class="btn btn-sm btn-outline-secondary">
                        Create new session
                    </a>
                </div>
            </div>
        </div>
    </div>

    <div class="table-responsive sessions">
        <table class="table table-striped">
            <thead>
            <tr>
                <th>Time</th>
                <th>Type</th>
                <th class="w-100">Title</th>
                <th>Speaker</th>
                <th>Channel</th>
            </tr>
            </thead>
            <tbody>
            @foreach($event->channels as $channel)
                @foreach($channel->rooms as $room)
                    @foreach($room->sessions as $session)
                        <tr>
                            <td class="text-nowrap">{{$session->start->format('H:i')}} - {{$session->end->format('H:i')}}</td>
                            <td>{{$session->type}}</td>
                            <td><a href="{{route('sessions.edit', [$event->id, $session->id])}}">{{$session->title}}</a></td>
                            <td class="text-nowrap">{{$session->speaker}}</td>
                            <td class="text-nowrap">{{$channel->name}} / {{$room->name}}</td>
                        </tr>
                    @endforeach
                @endforeach
            @endforeach
            </tbody>
        </table>
    </div>

    <!-- Channels -->
    <div id="channels" class="mb-3 pt-3 pb-2">
        <div class="d-flex justify-content-between flex-wrap flex-md-nowrap align-items-center">
            <h2 class="h4">Channels</h2>
            <div class="btn-toolbar mb-2 mb-md-0">
                <div class="btn-group mr-2">
                    <a href="{{route('channels.create', $event->id)}}" class="btn btn-sm btn-outline-secondary">
                        Create new channel
                    </a>
                </div>
            </div>
        </div>
    </div>

    <div class="row channels">
        @foreach($event->channels as $channel)
            <div class="col-md-4">
                <div class="card mb-4 shadow-sm">
                    <div class="card-body">
                        <h5 class="card-title">{{$channel->name}}</h5>
                        <p class="card-text">{{$channel->sessions->count()}} sessions, {{$channel->rooms->count()}} room</p>
                    </div>
                </div>
            </div>
        @endforeach
    </div>

    <!-- Rooms -->
    <div id="rooms" class="mb-3 pt-3 pb-2">
        <div class="d-flex justify-content-between flex-wrap flex-md-nowrap align-items-center">
            <h2 class="h4">Rooms</h2>
            <div class="btn-toolbar mb-2 mb-md-0">
                <div class="btn-group mr-2">
                    <a href="{{route('rooms.create', $event->id)}}" class="btn btn-sm btn-outline-secondary">
                        Create new room
                    </a>
                </div>
            </div>
        </div>
    </div>

    <div class="table-responsive rooms">
        <table class="table table-striped">
            <thead>
            <tr>
                <th>Name</th>
                <th>Capacity</th>
            </tr>
            </thead>
            <tbody>
            @foreach($event->channels as $channel)
                @foreach($channel->rooms as $room)
                    <tr>
                        <td>{{$room->name}}</td>
                        <td>{{number_format($room->capacity)}}</td>
                    </tr>
                @endforeach
            @endforeach
            </tbody>
        </table>
    </div>
@endsection

resources/views/events/edit.blade.php
@extends('layouts.app')

@section('main')
    <div class="border-bottom mb-3 pt-3 pb-2">
        <div class="d-flex justify-content-between flex-wrap flex-md-nowrap align-items-center">
            <h1 class="h2">{{$event->name}}</h1>
        </div>
    </div>

    <form class="needs-validation" novalidate action="{{route('events.update', $event->id)}}" method="POST">
        @csrf
        @method('PUT')

        <div class="row">
            <div class="col-12 col-lg-4 mb-3">
                <label for="inputName">Name</label>
                <!-- adding the class is-invalid to the input, shows the invalid feedback below -->
                <input type="text" class="form-control @if($errors->has('name')) is-invalid @endif" id="inputName"
                       name="name" placeholder="" value="{{old('name', $event->name)}}">
                @if($errors->has('name'))
                    <div class="invalid-feedback">
                        {{$errors->first('name')}}
                    </div>
                @endif
            </div>
        </div>

        <div class="row">
            <div class="col-12 col-lg-4 mb-3">
                <label for="inputSlug">Slug</label>
                <input type="text" class="form-control @if($errors->has('slug')) is-invalid @endif" id="inputSlug"
                       name="slug" placeholder="" value="{{old('slug', $event->slug)}}">
                @if($errors->has('slug'))
                    <div class="invalid-feedback">
                        {{$errors->first('slug')}}
                    </div>
                @endif
            </div>
        </div>

        <div class="row">
            <div class="col-12 col-lg-4 mb-3">
                <label for="inputDate">Date</label>
                <input type="text"
                       class="form-control @if($errors->has('date')) is-invalid @endif"
                       id="inputDate"
                       name="date"
                       placeholder="yyyy-mm-dd"
                       value="{{old('date', $event->date)}}">
                @if($errors->has('date'))
                    <div class="invalid-feedback">
                        {{$errors->first('date')}}
                    </div>
                @endif
            </div>
        </div>

        <hr class="mb-4">
        <button class="btn btn-primary" type="submit">Save</button>
        <a href="{{route('events.show', $event->id)}}" class="btn btn-link">Cancel</a>
    </form>
@endsection

resources/views/events/index.blade.php
@extends('layouts.app')

@section('main')
    <div
        class="d-flex justify-content-between flex-wrap flex-md-nowrap align-items-center pt-3 pb-2 mb-3 border-bottom">
        <h1 class="h2">Manage Events</h1>
        <div class="btn-toolbar mb-2 mb-md-0">
            <div class="btn-group mr-2">
                <a href="{{route('events.create')}}" class="btn btn-sm btn-outline-secondary">Create new event</a>
            </div>
        </div>
    </div>

    <div class="row events">
        @foreach ($events as $event)
            <div class="col-md-4">
                <div class="card mb-4 shadow-sm">
                    <a href="{{route('events.show', $event->id)}}" class="btn text-left event">
                        <div class="card-body">
                            <h5 class="card-title">{{$event->name}}</h5>
                            <p class="card-subtitle">{{$event->date}}</p>
                            <hr>
                            <p class="card-text">{{number_format($event->registrations->count())}} registrations</p>
                        </div>
                    </a>
                </div>
            </div>
        @endforeach
    </div>
@endsection